# gamestar.tcl v1.2 by domsen <domsen@domsen.org> (c)2oo1
#
# comments? bugs? ideas? plz mail me :)
#
# das tcl liest die gamestar.de gaming news aus und gibt
# sie wieder, auf wunsch den passenden link und eine msg
# wenn neue newslines auf der page sind.
#
# .gamestar - gibt die 'gamestarlimit' newslines wieder
# .gamestarlink <nr> - gibt den zur nummer passenden 
#                      link wieder
# gamestarlimit "" fr unbegrenzte newsline, ansonsten sollte
#                  ein limit von ca 10 gesetzt werden
# gsnewspost - 1 fr newsposting, 0 fr keines
#
# gamestarchans - die chans in denen das tcl aktiv ist, wobei
#                 "" fr alle steht
# isgamestarhub legt fest ob der bot newshub ist oder nicht, das
# leaf tcl ist auch auf www.domsen.org verfgbar.
#
# gamestarleafs sind die nicks der leafbots auf denen das leaf tcl
# luft
#
# alle commands sind pub und per msg verfgbar
#
# man htte dieses tcl auch simpler coden knnen durch den
# gebrauch von regusbs und wget, aber das wre zu einfach
# gewesen da man die regsub-strings aus den php backends
# benutzen knnte - wo bleibt da die herausforderung. wget
# ist auerdem nicht auf allen shells erlaubt, also habe ich
# mich fr lynx entschieden. die tcl http lib wollte ich auch
# nicht benutzen, da ich gerne auf fremden externen code
# vollkommen verzichte :-)
#
####### config ######################

set gstrigger ".gamestar"
set gssearchtrigger ".gamestarlink"
set gamestarchans ""
set gamestarlimit "10"
set gsnewspost "1"
set isgamestarhub "1"
set gamestarleafs ""

####### ende der config #############

bind msg - $gstrigger msg_gs
bind pub - $gstrigger pub_gs
bind msg - $gssearchtrigger gsmsg_search
bind pub - $gssearchtrigger gspub_search
bind time - "?0 * * * *" gscheck

proc sendgamestarnews { arg } {
global gamestarleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $gamestarleafs] [string tolower $bot]] != -1)} {
putbot $bot "gamestar: $arg"
}}}


proc gscheck { nick uhost hand chan arg } {
global  gamestarchans gsnewspost isgamestarhub
if {$gsnewspost == 1 } {
set gslastnews "none"
set gshdlfile "gamestar.hdl"
if {[file exists $gshdlfile]} {
putlog "gamestar: suche nach neuer newsline"
set temp [open "gamestar.hdl" r]
set counter 0
set hehe " "
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Aktuelle Schlagzeilen" $zeile] != -1)} {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first "Aktuelle Schlagzeilen" $zeile] == -1) && ([string first ":" $zeile] != "-1")} {
incr counter
set gslastnews [string range $zeile 16 [string length $zeile]]
}} 
close $temp
}
# rip neu
exec lynx -preparsed -dump http://www.gamestar.de/default.htm > gamestar.hdl
set temp [open "gamestar.hdl" r]
set counter 0
set hehe " "
if {$gslastnews == "none" } { 
putlog "gamestar: headlinefile created"
return 0 
}
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Aktuelle Schlagzeilen" $zeile] != -1)} {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first "Aktuelle Schlagzeilen" $zeile] == -1) && ([string first ":" $zeile] != "-1")} {
incr counter
set gsneunews [string range $zeile 16 [string length $zeile]]

if {$gslastnews == $gsneunews} { incr counter }
if {$gslastnews != $gsneunews} {
putlog "gamestar: neue newsline"
if { $isgamestarhub == "1" } { sendgamestarnews $gsneunews }
foreach chan [channels] {
if {$gamestarchans == "" } { putserv "privmsg $chan :(neue gamestar newsline) $gsneunews" }
if {$gamestarchans != "" } {
if {([lsearch -exact [string tolower $gamestarchans] [string tolower $chan]] != -1) || ($gamestarchans == "")} {
putserv "privmsg $chan :(neue gamestar newsline) $gsneunews"
}}}}}}
close $temp
}}






proc gsmsg_search { nick uhost hand arg } {
global year
exec lynx -preparsed -dump http://www.gamestar.de/default.htm > gamestar.temp
set temp [open "gamestar.temp" r]
set newslinenr 0
set counter 0
set linknr 0
set checker "duh"
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Aktuelle Schlagzeilen" $zeile] != -1)} {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first "Aktuelle Schlagzeilen" $zeile] == -1) && [string first ":" $zeile] != "-1" } {
incr newslinenr }
if { $arg == $newslinenr } {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.gamestar.de/aktuell/news"
set checker "ok"
}
if {($checker == "ok") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "privmsg $nick :$hyperlink"
putlog "gamestar: link search by $nick"
set checker "duh"
}}
close $temp
}

proc gspub_search { nick uhost hand chan arg } {
global year gamestarchans
if {([lsearch -exact [string tolower $gamestarchans] [string tolower $chan]] != -1) || ($gamestarchans == "")} {
exec lynx -preparsed -dump http://www.gamestar.de/default.htm > gamestar.temp
set temp [open "gamestar.temp" r]
set newslinenr 0
set counter 0
set linknr 0
set checker "duh"
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { ([string first "Aktuelle Schlagzeilen" $zeile] != -1)} {
incr counter }
if {($counter == "1") && ($zeile != "") && ([string first "Aktuelle Schlagzeilen" $zeile] == -1) && [string first ":" $zeile] != "-1" } {
incr newslinenr }
if { $arg == $newslinenr } {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.gamestar.de/aktuell/news"
set checker "ok"
set checker "ok"
}
if {($checker == "ok") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "notice $nick :$hyperlink"
putlog "gamestar: link search by $nick on $chan"
set checker "duh"
}}
close $temp
}}


proc msg_gs { nick uhost hand arg } {
global gamestarlimit
exec lynx -preparsed -dump http://www.gamestar.de/default.htm > gamestar.temp
if {($arg == "") && ($gamestarlimit != "")} {
set newslinenr 0
set counter 0
putserv "privmsg $nick :die letzten $gamestarlimit gamestar.de news"
set temp2 [open "gamestar.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Aktuelle Schlagzeilen" $zeile] != "-1" } {
incr counter }
if { [string first "Viele weitere aktuelle" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first ":" $zeile] != "-1"} {
set news [string range $zeile 16 [string length $zeile]]
if {$newslinenr < $gamestarlimit } {
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}}
close $temp2

putlog "gamestar: sent last $gamestarlimit newslines to $nick"
return 0 }
if {($arg == "all") || ($gamestarlimit == "")} {
set counter 0
set newslinenr 0
putserv "privmsg $nick :heutige gamestar.de news"
set temp2 [open "gamestar.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Aktuelle Schlagzeilen" $zeile] != "-1" } {
incr counter }
if { [string first "Viele weitere aktuelle" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first ":" $zeile] != "-1"} {
set news [string range $zeile 16 [string length $zeile]]
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}
close $temp2
putlog "gamestar: sent all newslines to $nick"
return 0}
}


proc pub_gs { nick uhost hand chan arg } {
global gamestarchans gamestarlimit
if {([lsearch -exact [string tolower $gamestarchans] [string tolower $chan]] != -1) || ($gamestarchans == "")} {
exec lynx -preparsed -dump http://www.gamestar.de/default.htm > gamestar.temp
if {($arg == "") && ($gamestarlimit != "")} {
set newslinenr 0
set counter 0
putserv "notice $nick :die letzten $gamestarlimit gamestar.de news"
set temp2 [open "gamestar.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Aktuelle Schlagzeilen" $zeile] != "-1" } {
incr counter }
if { [string first "Viele weitere aktuelle" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first ":" $zeile] != "-1"} {
set news [string range $zeile 16 [string length $zeile]]
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}
close $temp2
putlog "gamestar: sent last $gamestarlimit newslines to $nick on $chan"
return 0}
if {($arg == "all") || ($gamestarlimit == "")} {
set counter 0
set newslinenr 0
putserv "notice $nick :heutige gamestar.de news"
set temp2 [open "gamestar.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "Aktuelle Schlagzeilen" $zeile] != "-1" } {
incr counter }
if { [string first "Viele weitere aktuelle" $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first ":" $zeile] != "-1"} {
set news [string range $zeile 16 [string length $zeile]]
if {$newslinenr < $gamestarlimit } {
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}}
close $temp2
putlog "gamestar: sent all newslines to $nick on $chan"
return 0}
}}


putlog "*** gamestar.tcl v1.o by domsen succesfully loaded"

# [EOF]
